// Style Sheet Switcher version 1.1 Oct 10th, 2006
// Original Author: Dynamic Drive: http://www.dynamicdrive.com
// Usage terms: http://www.dynamicdrive.com/notice.htm

//
// cookie functions
//

function getCookie(Name) {
  var re = new RegExp(Name + "=[^;]+", "i"); //construct RE to search for target name/value pair
  if (document.cookie.match(re)) //if cookie found
    return document.cookie.match(re)[0].split("=")[1] //return its value
  return null
}

function setCookie(name, value, days) {
  //console.log('setting', name, value, days);
  var expireDate=new Date()
      //set "expstring" to either future or past date, to set or delete cookie, respectively
  var expstring=(typeof days!="undefined")?expireDate.setDate(expireDate.getDate()+parseInt(days)):expireDate.setDate(expireDate.getDate()-5)
  document.cookie=name+"="+value+"; expires="+expireDate.toGMTString()+"; path=/";
}

function deleteCookie(name) {
  setCookie(name, "moot")
}

//
// selectors
//

function setStylesheet(title, type, randomize) { //Main stylesheet switcher function. Second parameter if defined causes a random alternate stylesheet (including none) to be enabled
  var i, cacheobj, altsheets = [""]
  //console.log('got', document.getElementsByTagName("link").length);
  for (i = 0;
    (cacheobj = document.getElementsByTagName("link")[i]); i++) {
    //console.log('rel', cacheobj.getAttribute("rel").toLowerCase(), '==', type, 'title', cacheobj.getAttribute("title"));
    if (cacheobj.getAttribute("rel").toLowerCase() == type+" stylesheet" && cacheobj.getAttribute("title")) { //if this is an alternate stylesheet with title
      cacheobj.disabled = true
      altsheets.push(cacheobj) //store reference to alt stylesheets inside array
      //console.log(cacheobj.getAttribute("title"), '==', title);
      if (cacheobj.getAttribute("title") == title) //enable alternate stylesheet with title that matches parameter
        cacheobj.disabled = false //enable chosen style sheet
    }
  }
  if (typeof randomize != "undefined") { //if second paramter is defined, randomly enable an alt style sheet (includes non)
    var randomnumber = Math.floor(Math.random() * altsheets.length)
    altsheets[randomnumber].disabled = false
  }
  return (typeof randomize != "undefined" && altsheets[randomnumber] != "") ? altsheets[randomnumber].getAttribute("title") : "" //if in "random" mode, return "title" of randomly enabled alt stylesheet
}

// layout/color
function chooseStyle(styletitle, type) { //Interface function to switch style sheets plus save "title" attr of selected stylesheet to cookie
  var days=365*10; // remember this setting for 10 years
  if (document.getElementById) {
    setStylesheet(styletitle, type)
    if (type==="layout") {
      setCookie("mylayout", styletitle, days)
    } else {
      setCookie("mysheet", styletitle, days)
    }
  }
}

/*
function indicateSelected(element) { //Optional function that shows which style sheet is currently selected within group of radio buttons or select menu
  if (selectedtitle != null && (element.type == undefined || element.type == "select-one")) { //if element is a radio button or select menu
    var element = (element.type == "select-one") ? element.options : element
    for (var i = 0; i < element.length; i++) {
      if (element[i].value == selectedtitle) { //if match found between form element value and cookie value
        if (element[i].tagName == "OPTION") //if this is a select menu
          element[i].selected = true
        else //else if it's a radio button
          element[i].checked = true
        break
      }
    }
  }
}
*/


//
// Management
//

var sheets={
  'layout': [
    'Darkend',
    'Center',
  ],
  'color': [
    'Darkend',
    'DarkDili',
    'Tomorrow',
    'Yotsuba',
  ],
};

function buildSheets(type) {
  var helem=document.querySelector('head');
  for(var i in sheets[type]) {
    var file=sheets[type][i];
    var sheet=document.createElement('link');
    sheet.rel=type+' stylesheet';
    sheet.type='text/css';
    sheet.href="/.static/themes/"+type+"s/"+file.toLowerCase()+"_"+type+"s.css";
    sheet.title=file;
    // chrome glitches if you don't add them disabled
    sheet.disabled=true;
    //console.log('initialized', type, file);
    helem.appendChild(sheet);
  }
}

buildSheets('layout');
buildSheets('color');

function buildSelect(type) {
  var selem=document.querySelector('select[name=switch'+type+'control]');
  if (!selem) {
    console.log('no', type, 'select');
    return;
  }
  //console.log(altsheets);
  var opt=document.createElement('option');
  var titletype=type;
  titletype[0]=titletype[0].toUpperCase();
  opt.value='';
  opt.appendChild(document.createTextNode(titletype));
  selem.appendChild(opt);
  opt=document.createElement('option');
  opt.value='';
  opt.appendChild(document.createTextNode('Default/none'));
  selem.appendChild(opt);

  for(var i in sheets[type]) {
    //===undefined?'None':altsheets[i].title
    var title=sheets[type][i];
    //console.log('registering', type, title);
    var opt=document.createElement('option');
    opt.value=title;
    if (type==='layout') {
      //console.log(type, selectedlayout, '==', title);
      if (selectedlayout===title) {
        //opt.selected=true;
        title=title+'*';
      }
    } else {
      //console.log(type, selectedtitle, '==', title);
      if (selectedtitle===title) {
        //opt.selected=true;
        title=title+'*';
      }
    }
    if (opt.selected) console.log('selected');
    opt.appendChild(document.createTextNode(title));
    selem.appendChild(opt);
  }
}

document.addEventListener("DOMContentLoaded", function(event) {
  var c=document.querySelector('select[name=switchlayoutcontrol]');
  if (c) {
    buildSelect('layout');
    buildSelect('color');
  }
});

//
// Do shit
//

var selectedlayout = getCookie("mylayout")
console.log('layout is', selectedlayout);
if (selectedlayout != null) {
  //load user chosen style sheet from cookie if there is one stored
  setStylesheet(selectedlayout, "layout")
} else {
  // need to disable all additional layouts
  setStylesheet('none', "layout")
}

var selectedtitle = getCookie("mysheet")
console.log('color is', selectedtitle);
if (selectedtitle != null) {
  //load user chosen style sheet from cookie if there is one stored
  setStylesheet(selectedtitle, "color")
} else {
  // need to disable all additional colors
  setStylesheet('none', "color")
}

// font sizes can be dealt with zoom
// font choices can be managed through user style sheets